using System;  
using System.Windows.Forms;  
  
namespace Utility 
{  
	public sealed class EventDispatcher 
	{  
		public static void Invoke(Control control, EventHandler handler, object sender, EventArgs args ) 
		{
			control.Invoke( new EventHandler( new EventDispatcher( handler, sender, args ).ProxyHandler));  
		}  
  
		private EventDispatcher( EventHandler realHandler, object sender, EventArgs args ) 
		{  
			this._realHandler = realHandler;  
			this._sender = sender;  
			this._args = args;  
		}  
  
		private EventHandler _realHandler;  
		private object   _sender;  
		private EventArgs  _args;  
		private object Sender 
		{  
			get { return( this._sender ); }  
		}  
  
		private EventArgs Args 
		{  
			get { return( this._args ); }  
		}  
  
		private EventHandler RealHandler 
		{  
			get { return( this._realHandler ); }  
		}  
  
		private void ProxyHandler( object sender, EventArgs args ) 
		{  
			this.RealHandler( this.Sender, this.Args );  
		}  
	}  
}  